CroquetParticipant subclass: #BlockOutParticipant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!


BlockOutParticipant subclass: #BlockOutMaster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!BlockOutMaster methodsFor: 'initialization' stamp: 'JD 5/3/2006 12:34'!
setup
	harness := CroquetHarness new.
	self setupWorld.
	harness addOverlay: self.! !

!BlockOutMaster methodsFor: 'initialization' stamp: 'JD 5/3/2006 12:45'!
setupWorld
	| space sync island portal spc pc rIsland rportal rpc portal3D rspace rspc |

	island := harness createIsland: ObserversWorld named: 'Observers'.
	space := island future at: #observersSpace.
	portal := island future at:#portal1.
	portal3D := island future at:#portal3D.
	spc := space future postcard.
	pc := portal future postcard.
	spc whenResolved:[
		harness addIsland: island postcard: spc value.
		sync := harness viewPortal future postcardLink: spc value.
		sync whenResolved:[harness startRender]. "ready to render"
	].

	rIsland := harness createIsland: BlockOutWorld named: 'BlockOut'.
	rspace := rIsland future at: #blockOutSpace.
	rspc := rspace future postcard.
	rportal := rIsland future at: #portal1.
	rpc := rportal future postcard.

	pc whenResolved:[
		rpc whenResolved:[
			harness addIsland: rIsland postcard: rpc value.
			portal future postcardLink: rpc value.
			rportal future postcardLink: pc value.
		].
	].

	rspc whenResolved:[
		portal3D future postcardLink: rspc value.
	].
! !


Object subclass: #BlockOutWorld
	instanceVariableNames: 'width height depth running step mesh shape space pause'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!BlockOutWorld methodsFor: 'initialize' stamp: 'JD 5/14/2006 16:43'!
initialize
	width := 5.
	height := 5.
	depth := 12.
	step := 1000.
	running := false.
	pause := false.

	space := TSpace new.

	self initWorld: space.

	mesh := Mesh withEngine: self.
	mesh translationX: (width / 2) negated y: (height / 2) negated z:10.
	space addChild: mesh.! !

!BlockOutWorld methodsFor: 'initialize' stamp: 'JD 5/6/2006 15:34'!
initWorld: space
	| portal win |

	space color: (VectorColor r:0.0 g:0.0 b:0.0 a:1.0).
	space registerGlobal:#blockOutSpace.
	TLight makeLights: space.

	win := TWindow new.
	space addChild: win.

	portal := TBlockedPortal new.
	portal registerGlobal:#portal1.
	win contents: portal.
	win translationX: 0.0 y: 0.0 z: 9.0.
! !

!BlockOutWorld methodsFor: 'initialize' stamp: 'Jd 5/8/2006 15:50'!
makeLights: space
	| light |

	light := TLight new.
	light ambientColor: #(0.3 0.4 0.5 0.6).
	light diffuseColor: #(0.48 0.35 0.4 0.6).
	light specularColor: #(0.3 0.23 0.2 0.5).
	light rotationAroundY: -130.
	light addRotationAroundX: 120.
	space addChild: light.
"	
	light := TLight new.
	light ambientColor: #(0.1 0.1 0.1 0.1).
	light diffuseColor: #(0.4 0.35 0.48 0.6).
	light specularColor: #(0.2 0.23 0.3 0.5).
	light rotationAroundY: 132.
	light addRotationAroundX: 120.
	space addChild: light.

	light := TLight new.
	light ambientColor: #(0.1 0.1 0.1 0.1).
	light diffuseColor: #(0.1 0.23 0.1 0.4).
	light specularColor: #(0.3 0.2 0.3 0.3).
	light rotationAroundY: 42.
	light addRotationAroundX: 120.
	space addChild: light.

	light := TLight new.
	light ambientColor: #(0.1 0.1 0.1 0.1).
	light diffuseColor: #(0.1 0.23 0.1 0.4).
	light specularColor: #(0.4 0.3 0.2 0.2).
	light rotationAroundY: -42.
	light addRotationAroundX: 120.
	space addChild: light."
! !


!BlockOutWorld methodsFor: 'drawing' stamp: 'JD 5/14/2006 23:41'!
repaint
	shape repaint.
! !


!BlockOutWorld methodsFor: 'accesing' stamp: 'JD 5/5/2006 16:21'!
depth
	^depth! !

!BlockOutWorld methodsFor: 'accesing' stamp: 'JD 5/5/2006 16:21'!
height
	^height! !

!BlockOutWorld methodsFor: 'accesing' stamp: 'JD 5/14/2006 16:43'!
pause
	pause := pause not! !

!BlockOutWorld methodsFor: 'accesing' stamp: 'JD 5/6/2006 14:32'!
running
	^running! !

!BlockOutWorld methodsFor: 'accesing' stamp: 'JD 5/6/2006 15:28'!
running: boolean
	running ifTrue: [running := boolean]
			 ifFalse: [
				running := boolean.
				self run]
	! !

!BlockOutWorld methodsFor: 'accesing' stamp: 'Jd 5/8/2006 15:26'!
shape
	^shape! !

!BlockOutWorld methodsFor: 'accesing' stamp: 'JD 5/5/2006 16:21'!
width
	^width! !


!BlockOutWorld methodsFor: 'running' stamp: 'Jd 5/8/2006 14:12'!
end
	running := false! !

!BlockOutWorld methodsFor: 'running' stamp: 'Jd 5/8/2006 18:57'!
generateNextShape
	| shapes r class |
	shape ifNotNil: [space removeChild: shape].

	shapes := TFallingShape class subclasses.
	r := shapes size atRandom.
	class := (shapes at: r) theNonMetaClass.

	shape := class onPosition: ((width // 2 + 1)@(height // 2 + 1)@0) withMesh: mesh.
	shape canFall ifFalse: [self end]
		ifTrue: [
			shape fall.
			space addChild: shape]! !

!BlockOutWorld methodsFor: 'running' stamp: 'JD 5/14/2006 16:44'!
run
	mesh clear.
	pause := false.
	self generateNextShape.
	self step.! !

!BlockOutWorld methodsFor: 'running' stamp: 'JD 5/14/2006 16:44'!
step
	running ifFalse: [^self].

	pause ifFalse: [
		mesh fall.
		shape fall].
	(self future: step) step! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BlockOutWorld class
	instanceVariableNames: ''!

!BlockOutWorld class methodsFor: 'instance creation' stamp: 'JD 5/3/2006 12:49'!
islandID
	^TObjectID readHexFrom: 'fedcba0987654321fedcba0987654321'! !


TPrimitive subclass: #Mesh
	instanceVariableNames: 'engine mesh width height depth mat pallete palleteSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!Mesh methodsFor: 'render' stamp: 'JD 5/6/2006 13:47'!
pick: pointer
	^true! !

!Mesh methodsFor: 'render' stamp: 'JD 5/6/2006 15:20'!
renderPrimitive: ogl
	ogl glBegin: GLLines.

	0 to: width do: [ :x |
		ogl glVertex3i(x, height, 0).
		ogl glVertex3i(x, height, depth).
		ogl glVertex3i(x, 0, 0).
		ogl glVertex3i(x, 0, depth).
		ogl glVertex3i(x, height, depth).
		ogl glVertex3i(x, 0, depth)].

	0 to: height do: [ :y |
		ogl glVertex3i(width, y, 0).
		ogl glVertex3i(width, y, depth).
		ogl glVertex3i(0, y, 0).
		ogl glVertex3i(0, y, depth).
		ogl glVertex3i(width, y, depth).
		ogl glVertex3i(0, y, depth)].

	0 to: depth do: [ :z |
		ogl glVertex3i(width, height, z).
		ogl glVertex3i(width, 0, z).
		ogl glVertex3i(0, height, z).
		ogl glVertex3i(0, 0, z).
		ogl glVertex3i(width, height, z).
		ogl glVertex3i(0, height, z).
		ogl glVertex3i(width, 0, z).
		ogl glVertex3i(0, 0, z)].

	ogl glEnd.
! !


!Mesh methodsFor: 'accessing' stamp: 'Jd 5/8/2006 14:05'!
engine
	^engine! !

!Mesh methodsFor: 'accessing' stamp: 'JD 5/5/2006 16:49'!
engine: anEngine
	engine := anEngine.
	self init.! !

!Mesh methodsFor: 'accessing' stamp: 'Jd 5/8/2006 19:02'!
isEmpty: point
	point x > width ifTrue: [^false].
	point y > height ifTrue: [^false].
	point z > depth ifTrue: [^false].
	point x < 1 ifTrue: [^false].
	point y < 1 ifTrue: [^false].
	point z < 1 ifTrue: [^false].

	(((mesh at: point x) at: point y) at: point z) ifNil: [^true].
	^false.! !

!Mesh methodsFor: 'accessing' stamp: 'JD 5/6/2006 13:29'!
setColor: aColor
	mat color: aColor.
	self material: mat.! !


!Mesh methodsFor: 'falling' stamp: 'Jd 5/8/2006 14:27'!
canFallLine: z
	1 to: width do: [ :x |
		1 to: height do: [ :y |
			(((mesh at: x) at: y) at: z) ifNil: [
				^false]]].
	^true! !

!Mesh methodsFor: 'falling' stamp: 'JD 5/31/2006 13:41'!
fall
	depth to: 1 by: -1 do: [ :temp |
		1 to: temp do: [ :z |
			(self canFallLine: z) ifTrue: [self fallLines: z]]]
! !

!Mesh methodsFor: 'falling' stamp: 'Jd 5/8/2006 16:17'!
fallCube: position
	| cube x y z |
	x := position x.
	y := position y.
	z := position z.

	cube := ((mesh at: x) at: y) at: z.
	cube ifNotNil: [
		((mesh at: x) at: y) at: z put: nil.
		z := z + 1.
		cube translation: (x - 0.5)@(y - 0.5)@(z - 0.5).
		cube setColor: (pallete at: z \\ palleteSize + 1).
		((mesh at: x) at: y) at: z put: cube]
! !

!Mesh methodsFor: 'falling' stamp: 'JD 5/6/2006 15:07'!
fallLines: z
	self removeLine: z.
	(z-1) to: 1 by: -1 do: [ :line |
		self fallLine: line].
	self fall.! !

!Mesh methodsFor: 'falling' stamp: 'JD 5/6/2006 15:02'!
fallLine: z
	1 to: width do: [ :x |
		1 to: height do: [ :y |
			self fallCube: x@y@z]].
	self fall.! !

!Mesh methodsFor: 'falling' stamp: 'JD 5/6/2006 15:30'!
removeLine: z
	| cube |
	1 to: width do: [ :x |
		1 to: height do: [ :y |
			cube := ((mesh at: x) at: y) at: z.
			cube ifNotNil: [
				self removeChild: cube.
				((mesh at: x) at: y) at: z put: nil]]]
! !


!Mesh methodsFor: 'hierarchy' stamp: 'Jd 5/8/2006 19:15'!
addCube: position
	| cube x y z |
	x := position x.
	y := position y.
	z := position z.

	z > 0 ifTrue: [
		(((mesh at: x) at: y) at: z) ifNil: [
			cube := TMeshCube new.
			cube translation: (x - 0.5)@(y - 0.5)@(z - 0.5).
			cube setColor: (pallete at: z \\ palleteSize + 1).
			self addChild: cube.
			((mesh at: x) at: y) at: z put: cube]]! !


!Mesh methodsFor: 'initialize' stamp: 'JD 5/6/2006 15:31'!
clear
	1 to: depth do: [ :z | self removeLine: z]! !

!Mesh methodsFor: 'initialize' stamp: 'Jd 5/8/2006 16:24'!
init
	width := engine width.
	height := engine height.
	depth := engine depth.

	mat := TMaterial new.
	self setColor: (VectorColor r:0.0 g:1.0 b:0.0 a:1.0).
	self initBounds.
	
	mesh := Array new: width.
	1 to: width do: [ :x |
		mesh at: x put: (Array new: height).
		1 to: height do: [ :y |
			(mesh at: x) at: y put: (Array new: depth).
			1 to: depth do: [ :z |
				((mesh at: x) at: y) at: z put: nil]]].

	palleteSize := 5.
	pallete := Array new: palleteSize.
	pallete at: 1 put: (VectorColor r: 1.0 g:0.0 b:0.0 a:1.0).
	pallete at: 2 put: (VectorColor r: 0.0 g:0.4 b:1.0 a:1.0).
	pallete at: 3 put: (VectorColor r: 1.0 g:1.0 b:0.0 a:1.0).
	pallete at: 4 put: (VectorColor r: 1.0 g:0.0 b:1.0 a:1.0).
	pallete at: 5 put: (VectorColor r: 0.12 g:0.44 b:0.06 a:1.0).
! !

!Mesh methodsFor: 'initialize' stamp: 'JD 5/6/2006 13:06'!
initBounds
	| location radius |
	
	location := (width / 2)@(height / 2)@(depth / 2).
	"radius := (((width / 2)*(width / 2)) + ((height / 2)*(height / 2)) + ((depth / 2)*(depth / 2))) sqrt."

	boundSphere := TBoundSphere localPosition: location radius: location length.
	boundSphere frame: self.
! !


!Mesh methodsFor: 'events' stamp: 'JD 5/6/2006 13:37'!
eventMask
	^EventKeyboard bitOr: EventPointerDown! !

!Mesh methodsFor: 'events' stamp: 'JD 5/14/2006 23:50'!
keyDown: event
	| shape |
	shape := engine shape.

	"Transcript show: event keyValue; cr."

	shape ifNotNil: [
		event keyValue = 30 ifTrue: [shape moveUp].
		event keyValue = 29 ifTrue: [shape moveRight].
		event keyValue = 31 ifTrue: [shape moveDown].
		event keyValue = 28 ifTrue: [shape moveLeft].
		event keyValue = 32 ifTrue: [shape fallToGround].
		event keyValue = 65 ifTrue: [shape rotateX].
		event keyValue = 83 ifTrue: [shape rotateY].
		event keyValue = 68 ifTrue: [shape rotateZ].
		event keyValue = 80 ifTrue: [engine pause].

		engine repaint
	]! !

!Mesh methodsFor: 'events' stamp: 'JD 5/6/2006 14:33'!
pointerDown: event
	engine running: true.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Mesh class
	instanceVariableNames: ''!

!Mesh class methodsFor: 'instance creation' stamp: 'JD 5/3/2006 13:27'!
withEngine: anEngine
	^super new engine: anEngine.! !


Object subclass: #ObserversWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!ObserversWorld methodsFor: 'initialize' stamp: 'JD 5/14/2006 17:12'!
initialize

	| space portal sky win p3 pic |

	space := TSpace new.
	space registerGlobal:#observersSpace.

	self makeLights: space.
	self makeFloor:space fileName:'lawn.bmp'.

	win := TWindow new.
	win translation: 0@0@-20.
	space addChild: win.

	portal := TBlockedPortal new.
	portal registerGlobal:#portal1.
	win contents: portal.

	sky := TSkyBox new initializeWithFileName: 'JUL'.
	space addChild: sky.
	sky step. "get going"

	p3 := TPortal3D new.
	p3 translation: 6@-1@0.
	p3 offset: 0@0@-15.
	p3 scale: 0.2.
	space addChild: p3.
	p3 registerGlobal:#portal3D.

	pic := self makeWebPage: 'help.html' extent: 512@256.
	win := TWindow new.
	win contents: pic.
	win translation: -10@0@-15.
	win rotationAroundY: 45.
	space addChild: win
! !

!ObserversWorld methodsFor: 'initialize' stamp: 'JD 5/3/2006 12:39'!
makeFloor: space fileName: txtrName

	| floor txtr |

	txtr := TTexture new initializeWithFileName: txtrName
				mipmap: true
				shrinkFit: false.
	txtr uvScale: 8.0@8.0.

	floor := TCube new.
	floor extentX:80 y:0.5 z: 80.
	floor translationX: 0 y: -6.0 z: 0.0.
	floor texture: txtr.
	floor objectName: 'floor' copy.
	space addChild: floor.

! !

!ObserversWorld methodsFor: 'initialize' stamp: 'JD 5/3/2006 12:39'!
makeLights: space

	| light |

"warm light in northwest corner."
	light := TLight new.
	light ambientColor: #(0.3 0.4 0.5 0.6).
	light diffuseColor: #(0.48 0.35 0.4 0.6).
	light specularColor: #(0.3 0.23 0.2 0.5).
	light rotationAroundY: -130.
	light addRotationAroundX: 120.
	space addChild: light.

"cool light diagonally opposite."
	light := TLight new.
	light ambientColor: #(0.1 0.1 0.1 0.1).
	light diffuseColor: #(0.4 0.35 0.48 0.6).
	light specularColor: #(0.2 0.23 0.3 0.5).
	light rotationAroundY: 132.
	light addRotationAroundX: 120.
	space addChild: light.

" fainter green light in third corner."
	light := TLight new.
	light ambientColor: #(0.1 0.1 0.1 0.1).
	light diffuseColor: #(0.1 0.23 0.1 0.4).
	light specularColor: #(0.3 0.2 0.3 0.3).
	light rotationAroundY: 42.
	light addRotationAroundX: 120.
	space addChild: light.

"and another opposite it"
	light := TLight new.
	light ambientColor: #(0.1 0.1 0.1 0.1).
	light diffuseColor: #(0.1 0.23 0.1 0.4).
	light specularColor: #(0.4 0.3 0.2 0.2).
	light rotationAroundY: -42.
	light addRotationAroundX: 120.
	space addChild: light.
! !

!ObserversWorld methodsFor: 'initialize' stamp: 'JD 5/14/2006 17:04'!
makeWebPage: url extent: pageExtent
	"Create a TMorphic containing nothing but a web page."
	| fakeSHA morphic txtr |
	fakeSHA := TFormManager generateSHA: TObjectID new.
	morphic := TMorphicForm new 
		initialize: nil sha: fakeSHA 
		form: (Form extent: 32@32 depth: 32)
		mipmap: false shrinkFit: true extension: nil. 
	morphic bThumb: true.
	morphic constructor: (MessageSend
			receiver: MorphicWorldHost
			selector: #makeWebPage:extent:from:
			arguments: {url}).
	morphic worldExtent: pageExtent.

	"@@@@ The following is VERY important since later we'll need the TMorphic's farRef but we cannot create it in render, so forcing it here is a must @@@@"
	morphic island asFarRef: morphic.

	txtr := TTextureHackForm new initializeWithTForm: morphic.
	txtr targetExtent: pageExtent.
	^txtr! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ObserversWorld class
	instanceVariableNames: ''!

!ObserversWorld class methodsFor: 'as yet unclassified' stamp: 'JD 5/3/2006 12:47'!
islandID
	^TObjectID readHexFrom: '1234567890abcdef1234567890abcdef'! !


TPortal subclass: #TBlockedPortal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!TBlockedPortal methodsFor: 'accessing' stamp: 'JD 5/6/2006 15:43'!
blocked
	^false! !


TPrimitive subclass: #TFallingShape
	instanceVariableNames: 'x y z mesh subCubes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!TFallingShape methodsFor: 'render' stamp: 'Jd 5/8/2006 18:05'!
renderPrimitive: ogl
! !

!TFallingShape methodsFor: 'render' stamp: 'JD 5/14/2006 23:44'!
repaint
	self translation: (x - (mesh engine width / 2))@(y - (mesh engine height / 2))@(z + 10)..! !


!TFallingShape methodsFor: 'initialize' stamp: 'Jd 5/8/2006 16:43'!
init: point
	x := point x.
	y := point y.
	z := point z.! !

!TFallingShape methodsFor: 'initialize' stamp: 'Jd 5/8/2006 16:43'!
mesh: aMesh
	mesh := aMesh! !


!TFallingShape methodsFor: 'rotating' stamp: 'Jd 5/8/2006 18:58'!
rotateX
	Transcript show: 'rototate x'; cr.
	subCubes do: [ :cube | cube canRotateX ifFalse: [^self]].
	Transcript show: 'ok'; cr.
	subCubes do: [ :cube | cube rotateX].
	! !

!TFallingShape methodsFor: 'rotating' stamp: 'Jd 5/8/2006 18:47'!
rotateY
	subCubes do: [ :cube | cube canRotateY ifFalse: [^self]].
	subCubes do: [ :cube | cube rotateY].
	! !

!TFallingShape methodsFor: 'rotating' stamp: 'Jd 5/8/2006 18:47'!
rotateZ
	subCubes do: [ :cube | cube canRotateZ ifFalse: [^self]].
	subCubes do: [ :cube | cube rotateZ].
	! !


!TFallingShape methodsFor: 'falling' stamp: 'Jd 5/8/2006 17:06'!
canFall
	subCubes do: [ :cube | cube canFall ifFalse: [^false]].
	
	^true.! !

!TFallingShape methodsFor: 'falling' stamp: 'Jd 5/8/2006 17:10'!
fall
	self canFall ifTrue: [self fallDown]
		ifFalse: [
			subCubes do: [ :cube | mesh addCube: (x + cube x)@(y + cube y)@(z + cube z)].
			mesh engine generateNextShape]! !

!TFallingShape methodsFor: 'falling' stamp: 'JD 5/14/2006 23:44'!
fallDown
	z := z + 1.
	self repaint.! !

!TFallingShape methodsFor: 'falling' stamp: 'JD 5/14/2006 23:51'!
fallToGround
	[self canFall] whileTrue: [self fall].
	self fall.! !


!TFallingShape methodsFor: 'moving' stamp: 'Jd 5/8/2006 18:35'!
moveDown
	subCubes do: [ :cube | cube canMoveDown ifFalse: [^self]].

	y := y - 1.
! !

!TFallingShape methodsFor: 'moving' stamp: 'Jd 5/8/2006 18:35'!
moveLeft
	subCubes do: [ :cube | cube canMoveLeft ifFalse: [^self]].

	x := x + 1.
! !

!TFallingShape methodsFor: 'moving' stamp: 'Jd 5/8/2006 18:35'!
moveRight
	subCubes do: [ :cube | cube canMoveRight ifFalse: [^self]].

	x := x - 1.
! !

!TFallingShape methodsFor: 'moving' stamp: 'Jd 5/8/2006 17:20'!
moveToGround
	self fall! !

!TFallingShape methodsFor: 'moving' stamp: 'Jd 5/8/2006 18:35'!
moveUp
	subCubes do: [ :cube | cube canMoveUp ifFalse: [^self]].

	y := y + 1.
! !


!TFallingShape methodsFor: 'accessing' stamp: 'Jd 5/8/2006 17:18'!
mesh
	^mesh! !

!TFallingShape methodsFor: 'accessing' stamp: 'Jd 5/8/2006 17:51'!
x
	^x! !

!TFallingShape methodsFor: 'accessing' stamp: 'Jd 5/8/2006 17:51'!
y
	^y! !

!TFallingShape methodsFor: 'accessing' stamp: 'Jd 5/8/2006 17:51'!
z
	^z! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

TFallingShape class
	instanceVariableNames: ''!

!TFallingShape class methodsFor: 'class initialization' stamp: 'Jd 5/8/2006 17:59'!
onPosition: position withMesh: aMesh
	| object |
	object := super new.
	object init: position.
	object mesh: aMesh.
	object translation:(aMesh engine width / 2)@(aMesh engine height / 2)@10.
	^object! !


TFallingShape subclass: #TFallingShapeCorner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!TFallingShapeCorner methodsFor: 'initialize' stamp: 'Jd 5/8/2006 19:11'!
initialize
	| cube |
	super initialize.
	subCubes := OrderedCollection new.

	cube := TSubCube at:0@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:1@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:1@1@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.! !


TFallingShape subclass: #TFallingShapeL
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!TFallingShapeL methodsFor: 'initialize' stamp: 'Jd 5/8/2006 19:09'!
initialize
	| cube |
	super initialize.
	subCubes := OrderedCollection new.

	cube := TSubCube at:(-1)@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:0@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:1@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:1@1@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.! !


TFallingShape subclass: #TFallingShapeOne
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!TFallingShapeOne methodsFor: 'initialize' stamp: 'Jd 5/8/2006 19:08'!
initialize
	| cube |
	super initialize.
	subCubes := OrderedCollection new.

	cube := TSubCube at:0@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube! !


TFallingShape subclass: #TFallingShapeQuad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!TFallingShapeQuad methodsFor: 'initialize' stamp: 'Jd 5/8/2006 19:09'!
initialize
	| cube |
	super initialize.
	subCubes := OrderedCollection new.

	cube := TSubCube at:0@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:1@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:0@1@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:1@1@0 withShape: self.
	subCubes add: cube.
	self addChild: cube! !


TFallingShape subclass: #TFallingShapeT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!TFallingShapeT methodsFor: 'initialize' stamp: 'Jd 5/8/2006 19:10'!
initialize
	| cube |
	super initialize.
	subCubes := OrderedCollection new.

	cube := TSubCube at:(-1)@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:0@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:1@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:0@1@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.! !


TFallingShape subclass: #TFallingShapeThree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!TFallingShapeThree methodsFor: 'initialize' stamp: 'Jd 5/8/2006 19:09'!
initialize
	| cube |
	super initialize.
	subCubes := OrderedCollection new.

	cube := TSubCube at:(-1)@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:0@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:1@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube! !


TFallingShape subclass: #TFallingShapeTwo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!TFallingShapeTwo methodsFor: 'initialize' stamp: 'Jd 5/8/2006 19:09'!
initialize
	| cube |
	super initialize.
	subCubes := OrderedCollection new.

	cube := TSubCube at:0@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:1@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube! !


TFallingShape subclass: #TFallingShapeZ
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!TFallingShapeZ methodsFor: 'initialize' stamp: 'Jd 5/8/2006 19:10'!
initialize
	| cube |
	super initialize.
	subCubes := OrderedCollection new.

	cube := TSubCube at:(-1)@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:0@0@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:0@1@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.

	cube := TSubCube at:1@1@0 withShape: self.
	subCubes add: cube.
	self addChild: cube.! !


TCube subclass: #TMeshCube
	instanceVariableNames: 'baseColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!TMeshCube methodsFor: 'accessing' stamp: 'JD 5/6/2006 13:53'!
setColor: bc

	| mat |

	mat := TMaterial new.
	mat color: bc.
	self material: mat.
	baseColor := bc.
! !


!TMeshCube methodsFor: 'events' stamp: 'Jd 5/8/2006 16:02'!
pick: pointer
	^false! !


TPrimitive subclass: #TSubCube
	instanceVariableNames: 'x y z shape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-BlockOut'!

!TSubCube methodsFor: 'moving' stamp: 'Jd 5/8/2006 17:42'!
canMoveDown
	^((y + shape y) > 1) and: [shape mesh isEmpty: (x + shape x)@(y + shape y - 1)@(z + shape z)]! !

!TSubCube methodsFor: 'moving' stamp: 'Jd 5/8/2006 17:43'!
canMoveLeft
	^((x + shape x) < shape mesh engine width) and: [shape mesh isEmpty: (x + shape x + 1)@(y + shape y)@(z + shape z)]
	! !

!TSubCube methodsFor: 'moving' stamp: 'Jd 5/8/2006 17:43'!
canMoveRight
	^((x + shape x) > 1) and: [shape mesh isEmpty: (x + shape x - 1)@(y + shape y)@(z + shape z)]
	! !

!TSubCube methodsFor: 'moving' stamp: 'Jd 5/8/2006 17:43'!
canMoveUp
	^((y + shape y) < shape mesh engine height) and: [shape mesh isEmpty: (x + shape x)@(y + shape y + 1)@(z + shape z)]
	! !


!TSubCube methodsFor: 'initialize' stamp: 'Jd 5/8/2006 18:07'!
initialize
	super initialize.
	self setColor: (VectorColor r:1.0 g:1.0 b:1.0 a:1.0).
! !

!TSubCube methodsFor: 'initialize' stamp: 'Jd 5/8/2006 17:14'!
init: point
	x := point x.
	y := point y.
	z := point z! !

!TSubCube methodsFor: 'initialize' stamp: 'Jd 5/8/2006 17:13'!
shape: aShape
	shape := aShape! !


!TSubCube methodsFor: 'falling' stamp: 'Jd 5/8/2006 17:50'!
canFall
	^shape mesh isEmpty: (x + shape x)@(y + shape y)@(z + shape z + 1).! !


!TSubCube methodsFor: 'render' stamp: 'Jd 5/8/2006 17:21'!
renderPrimitive: ogl
	ogl glBegin: GLLines.

	ogl glVertex3f(x - 1, y - 1, z - 1).
	ogl glVertex3f(x, y - 1, z - 1).

	ogl glVertex3f(x - 1, y, z - 1).
	ogl glVertex3f(x, y, z - 1).

	ogl glVertex3f(x - 1, y - 1, z).
	ogl glVertex3f(x, y - 1, z).

	ogl glVertex3f(x - 1, y, z).
	ogl glVertex3f(x, y, z).

	ogl glVertex3f(x - 1, y - 1, z - 1).
	ogl glVertex3f(x - 1, y, z - 1).

	ogl glVertex3f(x - 1, y - 1, z).
	ogl glVertex3f(x - 1, y, z).

	ogl glVertex3f(x, y - 1, z - 1).
	ogl glVertex3f(x, y, z - 1).

	ogl glVertex3f(x, y - 1, z).
	ogl glVertex3f(x, y, z).

	ogl glVertex3f(x - 1, y - 1, z - 1).
	ogl glVertex3f(x - 1, y - 1, z).

	ogl glVertex3f(x - 1, y, z - 1).
	ogl glVertex3f(x - 1, y, z).

	ogl glVertex3f(x, y - 1, z - 1).
	ogl glVertex3f(x, y - 1, z).

	ogl glVertex3f(x, y, z - 1).
	ogl glVertex3f(x, y, z).

	ogl glEnd.! !


!TSubCube methodsFor: 'accessing' stamp: 'Jd 5/8/2006 18:06'!
setColor: bc
	| mat |

	mat := TMaterial new.
	mat color: bc.
	self material: mat.! !

!TSubCube methodsFor: 'accessing' stamp: 'Jd 5/8/2006 17:53'!
x
	^x! !

!TSubCube methodsFor: 'accessing' stamp: 'Jd 5/8/2006 17:53'!
y
	^y! !

!TSubCube methodsFor: 'accessing' stamp: 'Jd 5/8/2006 17:53'!
z
	^z! !


!TSubCube methodsFor: 'rotating' stamp: 'Jd 5/8/2006 19:04'!
canRotateX
	^shape mesh isEmpty: (shape x + x)@(shape y + z negated)@(shape z + y)
! !

!TSubCube methodsFor: 'rotating' stamp: 'Jd 5/8/2006 19:04'!
canRotateY
	^shape mesh isEmpty: (shape x + z negated)@(shape y + y)@(shape z + x)
! !

!TSubCube methodsFor: 'rotating' stamp: 'Jd 5/8/2006 19:03'!
canRotateZ
	^shape mesh isEmpty: (shape x + y negated)@(shape y + x)@(shape z + z)
	! !

!TSubCube methodsFor: 'rotating' stamp: 'Jd 5/8/2006 18:51'!
rotateX
	| temp |
	temp := y.
	y := z negated.
	z := temp.! !

!TSubCube methodsFor: 'rotating' stamp: 'Jd 5/8/2006 18:53'!
rotateY
	| temp |
	temp := x.
	x := z negated.
	z := temp.! !

!TSubCube methodsFor: 'rotating' stamp: 'Jd 5/8/2006 18:54'!
rotateZ
	| temp |
	temp := x.
	x := y negated.
	y := temp.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

TSubCube class
	instanceVariableNames: ''!

!TSubCube class methodsFor: 'instance creation' stamp: 'Jd 5/8/2006 17:15'!
at: point withShape: aShape
	^(super new init: point) shape: aShape! !
